from sqlalchemy import delete, select, update
from sqlalchemy.ext.asyncio import AsyncSession
from module_admin.entity.do.explanation_content_type_do import ExplanationContentType
from module_admin.entity.vo.explanation_content_type_vo import Explanation_content_typeModel, Explanation_content_typePageQueryModel
from utils.page_util import PageUtil


class Explanation_content_typeDao:
    """
    讲解内容类型模块数据库操作层
    """

    @classmethod
    async def get_explanation_content_type_detail_by_id(cls, db: AsyncSession, content_type_id: int):
        """
        根据主键ID获取讲解内容类型详细信息

        :param db: orm对象
        :param content_type_id: 主键ID
        :return: 讲解内容类型信息对象
        """
        explanation_content_type_info = (
            (
                await db.execute(
                    select(ExplanationContentType)
                    .where(
                        ExplanationContentType.content_type_id == content_type_id
                    )
                )
            )
            .scalars()
            .first()
        )

        return explanation_content_type_info

    @classmethod
    async def get_explanation_content_type_detail_by_info(cls, db: AsyncSession, explanation_content_type: Explanation_content_typeModel):
        """
        根据讲解内容类型参数获取讲解内容类型信息

        :param db: orm对象
        :param explanation_content_type: 讲解内容类型参数对象
        :return: 讲解内容类型信息对象
        """
        explanation_content_type_info = (
            (
                await db.execute(
                    select(ExplanationContentType).where(
                    )
                )
            )
            .scalars()
            .first()
        )

        return explanation_content_type_info

    @classmethod
    async def get_explanation_content_type_list(cls, db: AsyncSession, query_object: Explanation_content_typePageQueryModel, is_page: bool = False):
        """
        根据查询参数获取讲解内容类型列表信息

        :param db: orm对象
        :param query_object: 查询参数对象
        :param is_page: 是否开启分页
        :return: 讲解内容类型列表信息对象
        """
        query = (
            select(ExplanationContentType)
            .where(
                ExplanationContentType.name.like(f'%{query_object.name}%') if query_object.name else True,
                ExplanationContentType.type_value == query_object.type_value if query_object.type_value else True,
                ExplanationContentType.create_time.like(f'%{query_object.create_time}%') if query_object.create_time else True,
                ExplanationContentType.update_time.like(f'%{query_object.update_time}%') if query_object.update_time else True,
            )
            .order_by(ExplanationContentType.content_type_id)
            .distinct()
        )
        # explanation_content_type_list = await PageUtil.paginate(db, query, query_object.page_num, query_object.page_size, is_page)
        explanation_content_type_list = (await db.execute(query)).scalars().all()
        return explanation_content_type_list

    @classmethod
    async def add_explanation_content_type_dao(cls, db: AsyncSession, explanation_content_type: Explanation_content_typeModel):
        """
        新增讲解内容类型数据库操作

        :param db: orm对象
        :param explanation_content_type: 讲解内容类型对象
        :return:
        """
        db_explanation_content_type = ExplanationContentType(**explanation_content_type.model_dump(exclude={}))
        db.add(db_explanation_content_type)
        await db.flush()

        return db_explanation_content_type

    @classmethod
    async def edit_explanation_content_type_dao(cls, db: AsyncSession, explanation_content_type: dict):
        """
        编辑讲解内容类型数据库操作

        :param db: orm对象
        :param explanation_content_type: 需要更新的讲解内容类型字典
        :return:
        """
        await db.execute(update(ExplanationContentType), [explanation_content_type])

    @classmethod
    async def delete_explanation_content_type_dao(cls, db: AsyncSession, explanation_content_type: Explanation_content_typeModel):
        """
        删除讲解内容类型数据库操作

        :param db: orm对象
        :param explanation_content_type: 讲解内容类型对象
        :return:
        """
        await db.execute(delete(ExplanationContentType).where(ExplanationContentType.content_type_id.in_([explanation_content_type.content_type_id])))

